<!--
title: Iterator
description: Folien für Iterator in Programmieren 1
url: https://git.haw-hamburg.de/pm1-tutorium/slides
header: Programmieren 1 **Tutorium**
footer: Henri Burau und Eva Meinen
-->

# Interface Iterable

zum Iterieren über eine Collection

```java
interface Iterable<T>{
	Iterator<T> iterator();
}
```

liefert Iterator über Elemente

```java
interface Iterator<T>{
	boolean hasNext();
	T next();
	void remove();
}
```

---

Anwendung:

```java
Iterator<Adress> iterator = adresses.iterator();
while( iterator.hasNext() ){
	Adress ad = iterator.next();
	System.out.printf("%s", ad.toString());
} 
```

alternativ:

```java
for(Adress ad : adresses) {
	System.out.printf("%s", ad.toString());
}
```
